/***************************************************************************/
/***** Projekt do TZD - jednoduchy databazovy program pracujici jak    *****/
/*****  				  sekvencne tak pomoci indexoveho souboru      *****/
/***** Autor: Kosturik Martin (L95289)								   *****/
/***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <stdlib.h>

#define UP      72
#define DOWN    80
#define LEFT    75
#define RIGHT   77
#define INS     82
#define DEL     83
#define HOME    71
#define END     79
#define F2		60
#define F3      61
#define BACK	8
#define ENTER   13
#define ESC		27

void vystup(int prvni_radek, int index);
int  secti_radky(void);
void rosvit(void);
void zhasni(void);
void edit(void);
void vloz_radek(void);
void sort(void);
void refresh(int index, char jmeno_indexu[]);
int hledej(void);

int x = 4, y = 2, suma_radku;
char cache[30];
FILE *fp, *fp_index;


int main(void)
{
	int  i, doraz, n, key, pozice, znak, index = -1, xx, yy;
	long int l;
	char	jmeno_souboru[13], jmeno_indexu[13], jmeno_tmp[13],
			jmeno[9], poradi[3];
	FILE *fp_tmp;

	poradi[2] = jmeno[9] = '\0';
	textcolor(LIGHTGRAY);
	textbackground(BLACK);
	clrscr();
	printf("\nZadej jmeno souboru (bez pripony) : ");
	scanf("%8s", jmeno);
	sprintf(jmeno_souboru,"%s.dat",jmeno);
	sprintf(jmeno_indexu,"%s.idx",jmeno);
	sprintf(jmeno_tmp,"%s.tmp",jmeno);
	fp = fopen(jmeno_souboru, "r+");
	fp_index = fopen(jmeno_indexu, "w+");
	if(fp == NULL) {
		fp = fopen(jmeno_souboru, "w");
		vloz_radek();
		fclose(fp);
		fp = fopen(jmeno_souboru, "r+");
	}
	suma_radku = secti_radky();

	refresh(index, jmeno_indexu);

	_setcursortype(_NOCURSOR);
	pozice = 0;
	vystup(pozice, index);

	for(;;) {

		if(kbhit()) {
			key = getch();
			if(isupper(key))
				key = tolower(key);

			if(key == ESC)
				break;

	  if(key == 0)
			 key = getch();
			switch (key) {

				case UP:  	if(y == 2) {
								if(pozice != 0) {
									vystup(--pozice, index);
								}
							}
							else {  zhasni();
									--y;
									rosvit();
							}
							break;

				case DOWN:  if(suma_radku > 21)
								doraz = 23;
							else 	doraz = suma_radku + 2;
							if(y == doraz) {
								if((suma_radku - pozice) > 21) {
									vystup(++pozice, index);
								}
							}
							else {  zhasni();
									++y;
									rosvit();
							}
							break;

				case LEFT:   if(x != 4) {
								zhasni();
								x -= 18;
								rosvit();
							}
							break;

				case RIGHT:   if(x != 58) {
								zhasni();
								x += 18;
								rosvit();
							}
							break;

				case ENTER: gotoxy(x, y);
							edit();
							fseek(fp_index, (pozice + y - 2) * 22 + 17, SEEK_SET);
							fgets(poradi, 3, fp_index);
							l = atoi(poradi) * 67 + (8 * x - 23) / 9;
							fseek(fp, l, SEEK_SET);
							for(i = 0; i < 30; i += 2)
								fputc(cache[i], fp);
							refresh(index, jmeno_indexu);
							if(index == 1)
								vystup(pozice, index);
							gotoxy(x, y);
							_setcursortype(_NOCURSOR);
							break;

				case INS:   fseek(fp, 0L, SEEK_END);
							fputc('\n', fp);
							vloz_radek();
							++suma_radku;
							if(index == -1) {
								if(suma_radku > 21) {
									pozice = suma_radku - 21;
									y = 23;
								}
								else {	pozice = 0;
										y = suma_radku + 2;
								}
							}
							else {	 y = 2;
									 pozice = 0;
							}
							refresh(index, jmeno_indexu);
							for(i = 0; i < 30; i += 2)
								cache[i] = ' ';
							vystup(pozice, index);
							break;

				case DEL:   if(!suma_radku) break;
							fp_tmp = fopen(jmeno_tmp, "w");
							rewind(fp_tmp);
							fseek(fp_index, (pozice + y - 2) * 22 + 17, SEEK_SET);
							fgets(poradi, 3, fp_index);
							l = atoi(poradi);
							if(l) {
								rewind(fp);
								for(i = 1; i < (l * 66); ++i)
									fputc(fgetc(fp), fp_tmp);
							}
							if(l && l!= suma_radku)
								fputc('\n', fp_tmp);
							if(l != suma_radku) {
								fseek(fp, (l + 1) * 67L, SEEK_SET);
								for(i = 1; i < (suma_radku - l) * 66; ++i)
									fputc(fgetc(fp), fp_tmp);
							}
							fclose(fp_tmp);
							fclose(fp);
							remove(jmeno_souboru);
							rename(jmeno_tmp, jmeno_souboru);
							fp = fopen(jmeno_souboru, "r+");
							if((suma_radku - pozice) <= 21 && pozice != 0)
                            	--pozice;
							else if((pozice + y - 2) == suma_radku)
									--y;
							--suma_radku;
							refresh(index, jmeno_indexu);
							vystup(pozice, index);
							break;

				case F2:	xx = x;
							yy = y;
							i = hledej();
							if(i == -1)	{
								gotoxy(1, 24);
								printf("%55s", "ZADANA POLOZKA NEBYLA NALEZENA !");
								getch();
								gotoxy(1, 24);
								printf("%55s", "");
								x = xx;
								y = yy;
								rosvit();
								break;
							}
							n = (i / 22) * 22;
							if((suma_radku - n) > 22 || suma_radku < 22) {
									pozice = n;
									y = i % 22 + 2;
								}
								else {	pozice = i - n + 1;
										y = 23;
								}
							vystup(pozice, index);
							break;

				case F3:    index *= -1;
							refresh(index, jmeno_indexu);
							vystup(pozice, index);
			}
		}
	}
	refresh(1, jmeno_indexu);
	fclose(fp);
	fclose(fp_index);
	textcolor(LIGHTGRAY);
	textbackground(BLACK);
	_setcursortype(_NORMALCURSOR);
	clrscr();

return(0);
}

void vystup(int prvni_radek, int index)
{
	int i, j, doraz, znak, suma, radek;
	char poradi[3];

	poradi[2] = '\0';
	clrscr();
	textcolor(YELLOW);
	cprintf("Esc = Exit  Ins = Vlozi radek  Del = Smaze radek  F2 = Hleda polozku  F3 = ");
	if(index == -1)
			printf("INDEX");
	else	printf("SEKVC");
	textcolor(LIGHTGRAY);

	if((suma_radku - prvni_radek + 1) > 21)
			doraz = 22 + prvni_radek;
	else    doraz = suma_radku - prvni_radek + 1;
	for(i = prvni_radek; i < doraz; ++i) {
		fseek(fp_index, i * 22 + 17, SEEK_SET);
		fgets(poradi, 3, fp_index);
		j = atoi(poradi);

		suma = 15;
		radek = 0;
		rewind(fp);
		while((znak = fgetc(fp)) != EOF && radek < j) {
			if(znak == '\n')
				++radek;
		}
		ungetc(znak, fp);
		radek = 0;
		while((znak = fgetc(fp)) != EOF && radek < 1) {
			switch(znak) {
				case '#':	while(suma < 15) {
								printf(" ");
								++suma;
							}
							printf(" | ");
							suma = 0;
							break;
				case '\n':  printf("\n");
							suma = 15;
							++radek;
							break;
				default: 	printf("%c", znak);
							++suma;
			}
		}
		if(index && j == suma_radku)
			printf("\n");
	}
	rosvit();
return;
}


int secti_radky()
{
	int znak, suma_radku = 0;


	rewind(fp);
	while((znak = fgetc(fp)) != EOF) {
		if(znak == '\n')
			++suma_radku;
	}
return(suma_radku);
}


void rosvit(void)
{
	int i;

	gettext(x, y, x + 14, y, cache);
	for(i = 1; i < 30; i += 2)
		cache[i] = 79;
	puttext(x, y, x + 14, y, cache);


return;
}


void zhasni(void)
{
	int i;

	for(i = 1; i < 30; i += 2)
		cache[i] = 7;
	puttext(x, y, x + 14, y, cache);

return;
}


void vloz_radek(void)
{
	int i, n;

	fputc('#', fp);
	for(i = 0; i < 4; ++i) {
		for(n = 0; n < 15; ++n)
			fputc(' ', fp);
		fputc('#', fp);
	}
return;
}


void refresh(int index, char jmeno_indexu[])
{
	register int i, j, n;
	char polozka[16];

	fclose(fp_index);
	fp_index = fopen(jmeno_indexu, "w+");
	n = suma_radku + 1;
	polozka[15] = '\n';
	rewind(fp_index);
	for(i = 0; i < n; ++i) {
		fseek(fp, i * 67 + 1, SEEK_SET);
		fputc('#', fp_index);
		fputs(fgets(polozka, 16, fp), fp_index);
		fputc('#', fp_index);
		j = i / 10;
		fputc(48 + j, fp_index);
		fputc(48 + i - j * 10, fp_index);
		fputc('#', fp_index);
		fputc('\n', fp_index);
	}
	if(index == 1)
		sort();
return;
}


void sort(void)
{
	register int gap, i, j, n;
	char polozka[16], v[19], temp[19];

	n = suma_radku + 1;
	v[18] = temp[18] = '\n';
	gap = 1;
	do(gap = 3 * gap + 1);	while(gap <= n);
	for(gap /= 3; gap > 0; gap /= 3)
		for(i = gap; i < n; i++) {
			fseek(fp_index, i * 22 + 1, SEEK_SET);
			fgets(temp, 19, fp_index);
			j = i - gap;
			fseek(fp_index, j * 22 + 1, SEEK_SET);
			fgets(v, 19, fp_index);
			while((j >= 0) && (strncmp(v, temp, 15) > 0)) {
				fseek(fp_index, (j + gap) * 22 + 1, SEEK_SET);
				fputs(v, fp_index);
				j -= gap;
				fseek(fp_index, j * 22 + 1, SEEK_SET);
				fgets(v, 19, fp_index);
			}
			fseek(fp_index, (j + gap) * 22 + 1, SEEK_SET);
			fputs(temp, fp_index);
		}
return;
}


void edit(void)
{
	int key, i = 0;

	_setcursortype(_NORMALCURSOR);
	for(;;) {
		key = getch();
		if(key == ENTER)
			break;
		switch(key) {

			case 0:     key = getch();
						if(key == LEFT && i != 0)
							gotoxy(--i + x, y);
						if(key == RIGHT && i != 14)
							gotoxy(++i + x, y);
						break;

			case BACK:  if(i != 0) {
							printf("\b \b");
							cache[--i * 2] = ' ';
                        }
						break;

			default:    if(isprint(key) && key != '#') {
							printf("%c", key);
							cache[i * 2] = key;
							if(i == 14)
								printf("\b");
							else	++i;
						}
		}
	}
return;
}


int hledej(void)
{
	int i, l, n = 0;
	char hledana[16], nalezena[16];

	zhasni();
	x = 31;
	y = 24;
	gotoxy(1, 24);
	printf("ZADEJ NAZEV HLEDANE POLOZKY : ");
	for(i = 0; i < 30; i += 2)
		cache[i] = ' ';
	edit();
	_setcursortype(_NOCURSOR);

	hledana[15] = nalezena[15] = '\0';
	for(i = 0; i < 15; ++i)
		hledana[i] = cache[i * 2];
	for(i = 0; i <=  suma_radku; ++i) {
		for(x = 4; x <= 58; x += 18) {
			l = i * 67 + (8 * x - 23) / 9;
			fseek(fp, l, SEEK_SET);
			fgets(nalezena, 16, fp);
			if(strcmp(hledana, nalezena) == 0) {
				n = 1;
				break;
			}
		}
		if(n == 1) {
			fseek(fp, i * 67 + 1, SEEK_SET);
			fgets(hledana, 16, fp);
			for(i = 0; i <=  suma_radku; ++i) {
				fseek(fp_index, i * 22 + 1, SEEK_SET);
				fgets(nalezena, 16, fp_index);
				if(strcmp(hledana, nalezena) == 0)
					return(i);
			}
		}
	}
return(-1);
}